var home = Vue.component("Home", {
    template: `
    
    `,
    data: function() {
        return {
            dialog: false,
            pwd: null,
            items: [
                { title: 'LCS' },
                { title: 'Exit Store' }
            ],
            showAlert: false,
            alertMessage: '',
        }
    },
    mounted() {
        
    },
    computed: {
        form: function () {
            return {
                password: this.pwd
            }
        },
    },
    methods: {
        lcsDialog: function() {
            this.dialog = true;
        },
        lcsLogin: function() {
            this.showAlert = false;
            this.alertMessage = '';

            // Validate user and sign in LCS account
            let axiosOptions = {
                method: 'POST',
                url: app.dataUrl,
                data: { 'form': this.form },
                params: {
                    'action': 'signlcs'
                },
                headers: {
                    'Authorization': app.authKey
                },
                json: true
            };

            axios(axiosOptions)
            .then( response => { 
                // If everything is ok, go to thankyou page
                if( response.data.status == true ) {
                    app.store.isLcsLogged = true;
                    this.dialog = false;
                }
                else {
                    app.store.isLcsLogged = false;
                    this.pwd = '';
                    this.alertMessage = response.data.message;
                    this.showAlert = true;
                }
            })
            .catch(function (error) {
                console.log(error);
                this.processing = false;
            });
            
        },
        homeDialog: function(opt) {
            switch(opt) {
                case 'LCS':
                    this.lcsDialog();
                    break;
                case 'Exit Store':
                    localStorage.removeItem('m2m-selected-store');
                    app.storeDialog = true;
                    break;
            }
        },
    }
});