Vue.component("m2m-user-list", {
    template: `
    <div>
        <m2m-loading :loading="this.loading">
            <v-layout column>
                <v-flex>
                    <v-card flat>
                        <v-card-title primary-title>
                            <v-layout row>
                                <v-flex xs8>
                                    <div class="title">Users</div>
                                </v-flex>
                                <v-flex xs4 class="text-xs-right">
                                    <!-- Users Dialog -->
                                    <v-dialog v-model="dialog" fullscreen hide-overlay transition="dialog-bottom-transition">
                                        <v-btn small right class="ma-0" slot="activator" v-if="isEditable">Add New</v-btn>
                                        <v-card dark>
                                            <v-toolbar dark color="primary">
                                                <v-btn icon dark @click="closeDialog">
                                                    <v-icon>close</v-icon>
                                                </v-btn>
                                                <v-toolbar-title>{{ this.dialogTitle }}</v-toolbar-title>
                                                <v-spacer></v-spacer>
                                                <v-toolbar-items>
                                                    <v-btn dark flat @click="saveUser">Save</v-btn>
                                                </v-toolbar-items>
                                            </v-toolbar>
                                            <v-subheader>General Information</v-subheader>
                            
                                            <v-layout row>
                                                <v-flex xs4 sm12 class="ma-2 mb-0">
                                                    <v-text-field label="First Name" v-model="firstName"></v-text-field>
                                                </v-flex>
                                                <v-flex xs4 sm12 class="ma-2 mb-0">
                                                    <v-text-field label="Last Name" v-model="lastName"></v-text-field>
                                                </v-flex>
                                                <v-flex xs4 sm12 class="ma-2 mb-0">
                                                    <v-text-field label="Email" v-model="email"></v-text-field>
                                                </v-flex>
                                            </v-layout>
                                            <v-layout row>
                                                <v-flex xs12 class="ml-2 mr-2 mb-2">
                                                    <span v-if="!this.isEdit">Username: {{ newUserName }}</span>
                                                    <span v-if="this.isEdit">Username: {{ this.editUserName }}</span>
                                                </v-flex>
                                            </v-layout>
                                            <v-divider></v-divider>
                                            <v-list three-line subheader>
                                                <v-subheader>User Privileges</v-subheader>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.manageOrders"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Manage Orders</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view and modify orders</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.reports"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Reports</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to generate and export reports</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.manageUsers"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Manage Users</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view and modify users</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.manageStylist"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Manage Stylists</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view and modify stylists</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.manageReferrals"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Manage Referrals</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view and modify referrals</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.manageCoupons"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>Manage Coupons</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view and modify coupons</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.viewLog"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>View System Log</v-list-tile-title>
                                                        <v-list-tile-sub-title>User will be able to view the system log</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                                <v-list-tile avatar>
                                                    <v-list-tile-action>
                                                        <v-checkbox v-model="privileges.lcs"></v-checkbox>
                                                    </v-list-tile-action>
                                                    <v-list-tile-content>
                                                        <v-list-tile-title>LCS</v-list-tile-title>
                                                        <v-list-tile-sub-title>Grant user privilege to submit orders without deposit</v-list-tile-sub-title>
                                                    </v-list-tile-content>
                                                </v-list-tile>
                                            </v-list>
                                        </v-card>
                                    </v-dialog>
                                </v-flex>
                            </v-layout>
                        </v-card-title>
                        <v-card-text>
                            <v-layout row v-if="allowFilter">
                                <v-flex xs8></v-flex>
                                <v-flex xs4>
                                    <v-text-field v-model="search" append-icon="search" label="Filter" single-line hide-details></v-text-field>
                                </v-flex>
                            </v-layout>
                            <v-data-table :headers="this.headers" :items="this.users" :search="search" :hide-actions="!allowPagination">
                                <template slot="items" slot-scope="props">
                                    <td>{{ props.item.userName }}</td>
                                    <td>{{ toTitleCase(props.item.fullName) }}</td>
                                    <td>{{ props.item.lastLogin }}</td>
                                    <td>
                                        <v-checkbox v-model="props.item.active" primary hide-details @change="toggleUser(props.item)" :disabled="checkboxStatus"></v-checkbox>
                                    </td>
                                    <td class="justify-center layout px-0" v-if="isEditable">
                                        <v-icon small class="mr-2" @click="editUser(props.item)">
                                            edit
                                        </v-icon>
                                        <v-icon small class="mr-2" @click="openResetPwdDialog(props.item)">
                                            lock_open
                                        </v-icon>
                                    </td>
                                </template>
                            </v-data-table>
                        </v-card-text>
                    </v-card>
                </v-flex>
            </v-layout>
        </m2m-loading>
        <v-dialog v-model="pwdDialog" width="500" persistent>
            <v-card>
                <v-card-text>
                    <v-text-field label="Password" v-model="newPassword" type="password"></v-text-field>
                </v-card-text>

                <v-divider></v-divider>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn flat @click="pwdDialog = false">
                        Close
                    </v-btn>
                    <v-btn color="primary" flat @click="resetPwd">
                        RESET PASSWORD
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
    `,
    props: {
        editable: Boolean,
        allowFilter: Boolean,
        allowPagination: Boolean
    },
    data: function() {
        return { 
            loading: false,
            dialog: false,
            dialogTitle: 'New User',
            users: [],
            search: '',
            firstName: '',
            lastName: '',
            email: '',
            editUserName: '',
            privileges: {
                manageOrders: false,
                manageUsers: false,
                reports: false,
                manageStylist: false,
                manageReferrals: false,
                manageCoupons: false,
                viewLog: false,
                lcs: false
            },
            isEdit: false,
            pwdDialog: false,
            resetPwdUser: null,
            newPassword: '',
        }
    },
    computed: {
        headers: function() {
            if(this.isEditable) {
                return [
                    { text: 'Username', value: 'userName', width: '10%', sortable: true },
                    { text: 'Full Name', value: 'fullName', width: '40%', sortable: true },
                    { text: 'Last Login', value: 'lastLogin', width: '30%', sortable: true },
                    { text: 'Active', value: 'active', width: '10%', sortable: false },
                    { text: 'Edit', value: 'edit', width: '10%', sortable: false },
                ];
            }

            return [
                { text: 'Username', value: 'userName', width: '10%', sortable: true },
                { text: 'Full Name', value: 'name', width: '50%', sortable: true },
                { text: 'Last Login', value: 'lastLogin', width: '30%', sortable: true },
                { text: 'Active', value: 'active', width: '10%', sortable: false },
            ];
        },
        newUserName: function() {
            if (this.lastName.includes(' '))
                return (this.firstName.substr(0, 1) + this.lastName.substr(0, this.lastName.indexOf(' '))).toLowerCase();
            else 
                return (this.firstName.substr(0, 1) + this.lastName.substr(0, 8)).toLowerCase();
        },
        isEditable: function() {
            if (this.editable == null || this.editable == undefined)
                return false;
            
            return this.editable;
        },
        checkboxStatus: function() {
            return !this.isEditable; 
        },
    },
    created () {
        
    },
    mounted: function() {
        this.load();
    },
    methods: {
        load: function() {
            this.loading = true;
            
            axios
            .get( app.dataUrl + '?action=userlist', { })
                .then( response => { 
                    if(response.data.status ) {
                        this.users = response.data.data;
                    }

                    this.loading = false;
                });
        },
        toTitleCase: function (str) {
            return str.replace(/\-+/g, ' ').replace(/\w\S*/g, function(txt){
                return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
            });
        },
        editUser: function(user) {
            this.isEdit = true;
            this.editUserName = user.userName;
            this.firstName = user.firstName;
            this.lastName = user.lastName;
            this.email = user.email;
            this.privileges.manageOrders = user.manageOrder == 1 ? true : false;
            this.privileges.manageUsers = user.manageUser == 1 ? true : false;
            this.privileges.manageStylist = user.manageStylist == 1 ? true : false;
            this.privileges.manageReferrals = user.manageReferrals == 1 ? true : false;
            this.privileges.manageCoupons = user.manageCoupons == 1 ? true : false;
            this.privileges.viewLog = user.viewLog == 1 ? true : false;
            this.privileges.lcs = user.lcs == 1 ? true : false;
            this.privileges.reports = user.viewReports == 1 ? true : false;

            this.dialogTitle = 'Edit User';
            this.dialog = true;
        },
        saveUser: function() {
            this.loading = true;

            let formData = {
                userName: this.isEdit ? this.editUserName : this.newUserName,
                firstName: this.firstName,
                lastName: this.lastName,
                email: this.email,
                manageOrder: this.privileges.manageOrders,
                manageUser: this.privileges.manageUsers,
                manageStylist: this.privileges.manageStylist,
                manageReferral: this.privileges.manageReferrals,
                manageCoupon: this.privileges.manageCoupons,
                viewLog: this.privileges.viewLog,
                lcs: this.privileges.lcs,
                reports: this.privileges.reports,
                isEdit: this.isEdit
            };

            let axiosOptions = {
                method: 'POST',
                url: app.dataUrl,
                data: { 'form': formData },
                params: {
                    'action': 'admin.newuser'
                },
                json: true
            };

            axios(axiosOptions)
            .then( response => { 
                // If everything is ok, go to thankyou page
                if( !response.data.status ) {
                    // show error dialog
                    alert(response.data.error );
                    return;
                }
                else if(response.data.status == 'false' ) {
                    // show error dialog
                    alert(response.data.message );
                    return;
                }

                // Add/Edit the new user to the table
                if ( this.isEdit ) {
                    let editUser = this.users.find(user => {
                        return user.userName == formData.userName;
                    });

                    editUser.fullName = formData.firstName + ' ' + formData.lastName;
                    editUser.firstName = formData.firstName;
                    editUser.lastName = formData.lastName;
                    editUser.manageOrder = formData.manageOrder;
                    editUser.manageUser = formData.manageUser;
                    editUser.manageStylist = formData.manageStylist;
                    editUser.manageReferrals = formData.manageReferral;
                    editUser.manageCoupons = formData.manageCoupons;
                    editUser.viewLog = formData.viewLog;
                    editUser.lcs = formData.lcs;
                    editUser.viewReports = formData.reports;
                }
                else {
                    this.users.push(
                        { userName: response.data.userName, fullName: this.firstName + ' ' + this.lastName, lastLogin: '', active: true }
                    );
                }

                this.dialog = false;
                this.firstName = this.lastName = this.email = '';
                this.privileges.manageOrders = this.privileges.manageUsers = 
                this.privileges.manageStylist = this.privileges.manageReferrals = this.privileges.manageCoupons = 
                this.privileges.viewLog = this.privileges.lcs = this.privileges.reports = false;
                this.editUserName = '';
                this.isEdit = false;

                this.loading = false;
            })
            .catch(function (error) {
                console.log(error);
                this.loading = false;
            });
        },
        closeDialog: function() {
            this.dialog = false;
            this.firstName = this.lastName = this.email = '';
            this.privileges.manageOrders = this.privileges.manageUsers = 
            this.privileges.manageStylist = this.privileges.manageReferrals = this.privileges.manageCoupons = 
            this.privileges.viewLog = this.privileges.lcs = this.privileges.reports = false;
            this.editUserName = '';
            this.dialogTitle = 'New User';
            this.isEdit = false;
        },
        toggleUser: function(user) {
            let formData = {
                userName: user.userName,
                active: user.active
            };

            let axiosOptions = {
                method: 'POST',
                url: app.dataUrl,
                data: { 'form': formData },
                params: {
                    'action': 'admin.toggleuser'
                },
                json: true
            };

            axios(axiosOptions)
            .then( response => { 
                // If everything is ok, go to thankyou page
                if( !response.data.status ) {
                    // show error dialog
                    alert(response.data.error );
                    return;
                }
                else if(response.data.status == 'false' ) {
                    // show error dialog
                    alert(response.data.message );
                    return;
                }


                let editUser = this.users.find(user => {
                    return user.userName == formData.userName;
                });

                editUser.active = formData.active;
            })
            .catch(function (error) {
                console.log(error);
            });
        },
        openResetPwdDialog: function(user) {
            this.pwdDialog = true;
            this.resetPwdUser = user;
        },
        resetPwd: function() {
            let formData = {
                userName: this.resetPwdUser.userName,
                pwd: this.newPassword
            };

            let axiosOptions = {
                method: 'POST',
                url: app.dataUrl,
                data: { 'form': formData },
                params: {
                    'action': 'admin.changepwd'
                },
                json: true
            };

            axios(axiosOptions)
            .then( response => { 
                // If everything is ok, go to thankyou page
                if( !response.data.status ) {
                    // show error dialog
                    alert(response.data.error );
                    return;
                }
                else if(response.data.status == 'false' ) {
                    // show error dialog
                    alert(response.data.message );
                    return;
                }

                this.pwdDialog = false;
                this.newPassword = '';
            })
            .catch(function (error) {
                console.log(error);
            });
        }
    }
});