Vue.component('m2m-fabrics', {
    props: ['fabricCategories', 'edit'],
    template: `
    <div>
        <v-layout class="m2m-fabrics-wrapper" wrap>
            <v-flex xs12>
                <v-text-field v-model="query" solo clearable label="Search for fabrics" type="text" append-icon="search"></v-text-field>
            </v-flex>
            <v-flex class="" d-flex xs8>
                <!--<div class="swiper-container">
                    <div class="swiper-wrapper">
                        <div class="swiper-slide swiper-slide-sub-category" v-for="opt in fabricOptions" v-bind:key="opt.fabric_id" :class="opt.selected == true || opt.selected == 1 ? 'selected' : ''" @click="applyFabric(opt)">
                            <img :src="opt.image_url" width="80" height="80" style="border-radius:50%;" />
                        </div>
                    </div>
                </div>
                <ul class="list-inline sub-categories">
                    <li class="list-inline-item" v-for="opt in fabricOptions" v-bind:key="opt.fabric_id" :class="opt.selected == true || opt.selected == 1 ? 'selected' : ''" @click="applyFabric(opt)">
                        <img :src="opt.image_url" width="80" height="80" style="border-radius:50%;" />
                        {{ opt.name }}
                    </li>
                </ul>
                <v-list style="background:none;">
                    <v-text-field v-model="query" solo clearable label="Search" type="text" append-icon="search"></v-text-field>
                    <v-list-tile v-for="opt in fabricOptions" :key="opt.fabric_id" avatar class="mb-3" style="min-height:80px;" @click="">
                        <v-list-tile-avatar>
                            <v-avatar size="80"><img :src="opt.image_url" alt="avatar"></v-avatar>
                        </v-list-tile-avatar>
            
                        <v-list-tile-content class="ml-2">
                            <v-list-tile-title>{{ opt.name }}</v-list-tile-title>
                        </v-list-tile-content>
                    </v-list-tile>
                </v-list>-->
                <v-layout row wrap>
                    <v-flex xs6>
                        <div class="swiper-button-prev" style="transform: rotate(90deg);position:static;margin:0 auto;"></div>
                    </v-flex>
                    <v-flex xs6>
                        <div class="swiper-button-next" style="transform: rotate(90deg);position:static;margin:0 auto;"></div>
                    </v-flex>
                    <v-flex xs12>
                        <swiper ref="awesomeSwiper" :options="swiperOptions">
                            
                            <!-- slides -->
                            <swiper-slide v-for="opt in filterFabricOptions" :key="opt.fabric_id">
                                <v-layout row align-center fill-height>
                                    <v-flex xs7>
                                        <p class="title font-weight-thin" @click="applyFabric(opt)">{{ opt.name }}</p>
                                    </v-flex>
                                    <v-flex xs5>
                                        <div class="swiper-slide-sub-category" :class="opt.selected == true || opt.selected == 1 ? 'selected' : ''" @click="applyFabric(opt)">
                                            <img :src="opt.image_url" width="80" height="80" style="border-radius:50%;" v-if="opt.image_url.length > 0" />
                                        </div>
                                    </v-flex>
                                </v-layout>
                            </swiper-slide>
                        </swiper>
                    </v-flex>
                </v-layout>
            </v-flex>
            <v-flex d-flex xs4>
                <ul class="list-inline categories">
                    <li class="list-inline-item" v-for="cat in fabricCategories" v-bind:key="cat.fabric_option_id" @click="loadFabrics(cat)" :class="cat.selected == true || cat.selected == 1 ? 'selected' : ''">
                        {{ cat.name }}
                    </li>
                </ul>
            </v-flex>
        </v-layout>
        <v-dialog v-model="show" width="500" persistent>
            <v-card>
                <v-card-title>
                    <p class="title">Fabric Name</p>
                </v-card-title>
                <v-card-text>
                    <v-text-field label="Name" v-model="fabricName"></v-text-field>
                </v-card-text>

                <v-divider></v-divider>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" flat @click="addFabricName">
                        Save
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
    `,
    created() {
        serverBus.$on('editFabrics', () => {
            this.createFabrics();
            this.applyFabrics2SVG();
        });
        serverBus.$on('applyShirtFabrics', () => {
            this.applyFabrics2SVG();
        });
    },
    mounted: function() {
        // mySwiper = new Swiper ('.swiper-container', {
        //     // Optional parameters
        //     direction: 'vertical',
        //     loop: true,
        //     slidesPerView: 6,
        //     spaceBetween: 0,
        //     mousewheel: true
        //   });
        
    },
    updated: function () {
        // mySwiper.update();
    },
    data: function() {
        return {
            fabricOptions: null,
            mySwiper: null,
            query: null,
            swiperOptions: {
                direction: 'vertical',
                slidesPerView: 5,
                mousewheel: true,
                height: 550,
                navigation: {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev',
                }
            },
            show: false,
            fabricName: '',
            editOpt: null,
        }
    },
    computed: {
        swiper() {
          return this.$refs.awesomeSwiper.swiper
        },
        filterFabricOptions() {
            if(this.query == null || this.query == undefined || this.query.length == 0)
                return this.fabricOptions;

            let result = this.fabricOptions.filter(item => item.name.toUpperCase().includes(this.query.toUpperCase()));

            if( result.length == 0 )
                return [{ name: 'No fabrics available.', image_url: '', fabric_id: -1 }];
            else 
                return result;
        }
    },
    methods: {
        loadFabrics: function(cat) {
            app.store.availableFabrics = [];
            app.store.createdFabrics = [];
            axios
                .get( app.dataUrl + '?action=fabmod&c=' + cat.fabric_option_id + '&pid=' + app.store.productId, { headers: { Authorization: app.authKey } })
                .then( response => { 
                    this.fabricOptions = response.data.data;

                    // Add dummy fabric to use when the wanted fabric is not defined in the kiosk
                    this.fabricOptions.push({
                        fabric_id: -1,
                        image_url: 'https://leonardofifthavenue.com/wp-content/uploads/2018/11/LINING9-100x100.jpg',
                        name: 'Not Defined',
                        selected: 0
                    });

                    for( var i = 0; i < this.fabricOptions.length; i++ ) {
                        app.store.availableFabrics.push({
                            fabric_id: this.fabricOptions[i].fabric_id,
                            image_url: this.fabricOptions[i].image_url,
                            name: this.fabricOptions[i].name.replace(/\s+/g, '').toLowerCase()
                        });
                    }

                    var selectedOpt = app.store.fabrics.find(function(item) {
                        return item.fabric_option_id == cat.fabric_option_id;
                    });

                    if ( selectedOpt != null ) {
                        var opt = this.fabricOptions.find(function(item) {
                            return item.fabric_id == selectedOpt.fabric_id
                        });

                        this.cleanSelectedOpt();
                        opt.selected = true;
                    }

                    this.createFabrics();
                });
            
            this.cleanSelectedCat();
            cat.selected = true;
        },
        applyFabric: function(opt) {
            this.cleanSelectedOpt();
            opt.selected = true;

            if( opt.name == 'Not Defined' ) {
                this.editOpt = opt;
                this.show = true;
                return;
            }

            var category = this.fabricCategories.find(function(item) {
                return item.selected == true;
            });
            var exist = app.store.fabrics.find(function(item) {
                return item.fabric_option_id == category.fabric_option_id;
            });

            if ( exist ) {
                if ( exist.fabric_id == opt.fabric_id ) 
                    return;

                exist.fabric_id = opt.fabric_id;
                exist.fabric = opt.name.replace(/\s+/g, '').toLowerCase();
                exist.fabric_image = opt.image_url;
            }
            else {
                app.store.fabrics.push({
                    fabric_option_id: category.fabric_option_id,
                    fabric_option: category.name.replace(/\s+/g, '').toLowerCase(),
                    fabric_id: opt.fabric_id,
                    fabric: opt.name.replace(/\s+/g, '').toLowerCase(),
                    fabric_image: opt.image_url
                });
            }

            this.applyFabrics2SVG();
        },
        createFabrics: function() {
            var svg = document.getElementById( 'lcm-graphic' );
            var svgNS = svg.namespaceURI;

            var elements = document.getElementById("defs");
            var elementExist = true;
            
            if ( elements == null || elements == undefined ) {
                elements = document.createElementNS(svgNS, "defs");
                elements.setAttribute("id", "defs");
                elementExist = false;
            }

            for( var i = 0; i < app.store.availableFabrics.length; i++ ) {
                var img = app.store.availableFabrics[i].image_url;
                
                var exist = app.store.createdFabrics.find(function(item) {
                    return item.fabric_id == app.store.availableFabrics[i].fabric_id;
                });
                
                if( exist == null || exist == undefined ) {
                    
                    var pattern = document.createElementNS(svgNS, 'pattern');
                    pattern.setAttribute("id", app.store.availableFabrics[i].name);
                    pattern.setAttribute("patternUnits", "userSpaceOnUse");
                    pattern.setAttribute('width', '20');
                    pattern.setAttribute('height', '20');
                    
                    var image = document.createElementNS(svgNS, 'image');
                    image.setAttributeNS('http://www.w3.org/1999/xlink', "xlink:href", img);
                    image.setAttribute("x", '0');
                    image.setAttribute("y", '0');
                    image.setAttribute("width", '20');
                    image.setAttribute("height", '20');
                    
                    pattern.appendChild(image);
                    elements.appendChild(pattern);
                    
                    // Add fabric to store
                    app.store.createdFabrics.push({
                        fabric_id: app.store.availableFabrics[i].fabric_id
                    });
                }
            }

            if ( !elementExist )
                svg.prepend( elements );
        },
        applyFabrics2SVG: function() {
            for( var i = 0; i < app.store.fabrics.length; i++ ) {
                var svgClass = '';
                var fabricId = '#' + app.store.fabrics[i].fabric;
                let mod = null;

                switch( app.store.fabrics[i].fabric_option ) {
                    case 'lining':
                        svgClass = '.lcm-lining';
                        break;
                    case 'coatbody':
                        svgClass = '.lcm-coat-body';
                        break;
                    case 'upperlapel':
                        svgClass = '.lcm-upper-lapel';
                        break;
                    case 'lowerlapel':
                        svgClass = '.lcm-lower-lapel';
                        break;
                    case 'chestpocket':
                        svgClass = '.lcm-chest-pocket';
                        break;
                    case 'buttons':
                        svgClass = '.lcm-buttons';
                        break;
                    case 'pockets':
                        svgClass = '.lcm-pockets';
                        break;
                    case 'pantbody':
                        svgClass = ".lcm-pant-body";
                        break;
                    case 'body':
                        svgClass = ".lcm-body";
                        mod = app.store.modifications.find(function(item) {
                            return item.category == 'contrast';
                        });

                        if ( mod.option == 'neck-only' ) 
                            svgClass += ", .lcm-contrast.lcm-cuff";
                        else if ( mod.option == 'cuff-only' )
                            svgClass += ", .lcm-contrast.lcm-neck";
                        else if ( mod.option == 'no-contrast' )
                            svgClass += ', .lcm-contrast';
                        break;
                    case 'contrast':
                        mod = app.store.modifications.find(function(item) {
                            return item.category == 'contrast';
                        });

                        if ( mod.option == 'neck-only' ) 
                            svgClass = ".lcm-contrast.lcm-neck";
                        else if ( mod.option == 'cuff-only' )
                            svgClass = ".lcm-contrast.lcm-cuff";
                        else if ( mod.option == 'neck-and-cuff' )  
                            svgClass = '.lcm-contrast';
                        else if ( mod.option == 'no-contrast' )
                            svgClass = '';
                        break;
                    case 'satintape':
                        svgClass = ".lcm-satin-tape";
                        break;
                    case 'vestbody':
                        svgClass = ".lcm-vest-body";
                        break;
                }

                $('#lcm-graphic').find(svgClass).css('fill', 'url(' + fabricId + ') #FFFFFF');
            }
        },
        cleanSelectedCat: function() {
            for( var i = 0; i < this.fabricCategories.length; i++ )
                this.fabricCategories[i].selected = false;
        },
        cleanSelectedOpt: function() {
            for( var i = 0; i < this.fabricOptions.length; i++ )
                this.fabricOptions[i].selected = false;
        },
        addFabricName: function() {
            if( this.fabricName.length > 0 ) {
                this.editOpt.name = this.fabricName;
                
                var category = this.fabricCategories.find(function(item) {
                    return item.selected == true;
                });
                var exist = app.store.fabrics.find(function(item) {
                    return item.fabric_option_id == category.fabric_option_id;
                });
                
                if ( exist ) {    
                    exist.fabric_id = this.editOpt.fabric_id;
                    exist.fabric = this.editOpt.name.replace(/\s+/g, '').toLowerCase();
                    exist.fabric_image = this.editOpt.image_url;
                }
                else {
                    app.store.fabrics.push({
                        fabric_option_id: category.fabric_option_id,
                        fabric_option: category.name.replace(/\s+/g, '').toLowerCase(),
                        fabric_id: this.editOpt.fabric_id,
                        fabric: this.editOpt.name.replace(/\s+/g, '').toLowerCase(),
                        fabric_image: this.editOpt.image_url
                    });
                }

                this.show = false;
                this.fabricName = '';
                this.applyFabrics2SVG();
            }
            else {
                alert('You must enter the fabric name.');
            }
        }
    }
});