var home = Vue.component("Home", {
    template: `
    <v-app>
        <v-container fluid fill-width>
            <v-layout row wrap fluid>
                <v-flex xs12>
                    <p class="display-2">Welcome to the Made To Measure Kiosk!
                        <v-menu bottom class="right" offset-y left transition="slide-y-transition">
                            <v-btn slot="activator" dark icon>
                                <v-icon color="grey">more_vert</v-icon>
                            </v-btn>

                            <v-list>
                                <v-list-tile v-for="(item, i) in items" :key="i" @click="homeDialog(item.title)">
                                    <v-list-tile-title>{{ item.title }}</v-list-tile-title>
                                </v-list-tile>
                            </v-list>
                        </v-menu>
                    </p>
                </v-flex>
                <v-flex xs12>
                    <v-card>
                        <v-img height="900px" position="top center" src="assets/images/222A4455.jpg">
                        </v-img>
                    </v-card>
                </v-flex>
                <v-flex xs3>
                    <v-card>
                        <v-img height="600px" position="top center" src="assets/images/222A5066.jpg">
                        </v-img>
                    </v-card>
                </v-flex>
                <v-flex xs3>
                    <v-card>
                        <v-img height="600px" position="top center" src="assets/images/222A4707.jpg">
                        </v-img>
                    </v-card>
                </v-flex>
                <v-flex xs3>
                    <v-card>
                        <v-img height="600px" src="assets/images/222A5352.jpg">
                        </v-img>
                    </v-card>
                </v-flex>
                <v-flex xs3>
                    <v-card>
                        <v-img height="600px" src="assets/images/222A5311.jpg">
                        </v-img>
                    </v-card>
                </v-flex>
            </v-layout>
        </v-container>
        <div>
            <router-link to="/products"><v-btn color="red" dark large fixed bottom right>Start</v-btn></router-link>
        </div>
        <div class="text-xs-center">
            <v-dialog v-model="dialog" width="500">
                <v-card>
                    <v-card-text>
                        <p>Password</p>
                        <v-alert :value="showAlert" color="error" icon="warning">{{ this.alertMessage }}</v-alert>
                        <v-text-field label="" v-model="pwd" type="password"></v-text-field>
                    </v-card-text>

                    <v-divider></v-divider>

                    <v-card-actions>

                    <v-spacer></v-spacer>

                    <v-btn color="primary" flat @click="lcsLogin">
                        Login
                    </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </div>
    </v-app>`,
    data: function() {
        return {
            dialog: false,
            pwd: null,
            items: [
                { title: 'LCS' },
                { title: 'Exit Store' }
            ],
            showAlert: false,
            alertMessage: '',
        }
    },
    mounted() {
        
    },
    computed: {
        form: function () {
            return {
                password: this.pwd
            }
        },
    },
    methods: {
        lcsDialog: function() {
            this.dialog = true;
        },
        lcsLogin: function() {
            this.showAlert = false;
            this.alertMessage = '';

            // Validate user and sign in LCS account
            let axiosOptions = {
                method: 'POST',
                url: app.dataUrl,
                data: { 'form': this.form },
                params: {
                    'action': 'signlcs'
                },
                headers: {
                    'Authorization': app.authKey
                },
                json: true
            };

            axios(axiosOptions)
            .then( response => { 
                // If everything is ok, go to thankyou page
                if( response.data.status == true ) {
                    app.store.isLcsLogged = true;
                    this.dialog = false;
                }
                else {
                    app.store.isLcsLogged = false;
                    this.pwd = '';
                    this.alertMessage = response.data.message;
                    this.showAlert = true;
                }
            })
            .catch(function (error) {
                console.log(error);
                this.processing = false;
            });
            
        },
        homeDialog: function(opt) {
            switch(opt) {
                case 'LCS':
                    this.lcsDialog();
                    break;
                case 'Exit Store':
                    localStorage.removeItem('m2m-selected-store');
                    app.storeDialog = true;
                    break;
            }
        },
    }
});