var dashboard = Vue.component("m2m-admin-dashboard", {
    template: `<v-app id="dashboard">
  <v-layout row class="mb-3">
    <v-flex xs3>
      <v-card>
        <v-container fluid grid-list-md>
          <v-layout row>
            <v-flex xs4>
              <v-layout column>
                <v-flex>
                    <v-icon large color="blue darken-2">monetization_on</v-icon>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs8>
              <v-layout column>
                <v-flex xs12>
                    <h3 class="headline mb-0">{{ this.formatMoney( this.totalSaleIncome ) }} 
                      <span :class="this.isTotalSaleIncomeChangePositive ? 'caption green--text' : 'caption red--text text--lighten-2'">{{ this.formatPercentage(this.totalSaleIncomeChange) }}</span>
                      <v-icon :color="this.isTotalSaleIncomeChangePositive ? 'green' : 'red'" small>{{ this.isTotalSaleIncomeChangePositive ? 'arrow_upward' : 'arrow_downward' }}</v-icon></h3>
                </v-flex>
                <v-flex xs12>
                    <div>Last 30 days income</div>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-flex>
    <v-flex xs3 class="ml-2">
      <v-card>
        <v-container fluid grid-list-md>
          <v-layout row>
            <v-flex xs4>
              <v-layout column>
                <v-flex>
                    <v-icon large color="blue darken-2">receipt</v-icon>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs8>
              <v-layout column>
                <v-flex xs12>
                    <h3 class="headline mb-0">{{ this.totalOrders }}
                      <span :class="this.isTotalOrdersChangePositive ? 'caption green--text' : 'caption red--text text--lighten-2'">{{ this.formatPercentage(this.totalOrdersChange) }}</span>
                      <v-icon :color="this.isTotalOrdersChangePositive ? 'green' : 'red'" small>{{ this.isTotalOrdersChangePositive ? 'arrow_upward' : 'arrow_downward' }}</v-icon></h3>
                </v-flex>
                <v-flex xs12>
                    <div>Last 30 days orders</div>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-flex>
    <v-flex xs3 class="ml-2">
      <v-card>
        <v-container fluid grid-list-md>
          <v-layout row>
            <v-flex xs4>
              <v-layout column>
                <v-flex>
                    <v-icon large color="blue darken-2">receipt</v-icon>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs8>
              <v-layout column>
                <v-flex xs12>
                    <h3 class="headline mb-0">{{ this.totalItems }}
                      <span :class="this.isTotalItemsChangePositive ? 'caption green--text' : 'caption red--text text--lighten-2'">{{ this.formatPercentage(this.totalItemsChange) }}</span>
                      <v-icon :color="this.isTotalItemsChangePositive ? 'green' : 'red'" small>{{ this.isTotalItemsChangePositive ? 'arrow_upward' : 'arrow_downward' }}</v-icon></h3>
                </v-flex>
                <v-flex xs12>
                    <div>Last 30 days items sold</div>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-flex>
    <v-flex xs3 class="ml-2">
      <v-card>
        <v-container fluid grid-list-md>
          <v-layout row>
            <v-flex xs4>
              <v-layout column>
                <v-flex>
                    <v-icon large color="blue darken-2">receipt</v-icon>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs8>
              <v-layout column>
                <v-flex xs12>
                    <h3 class="headline mb-0">{{ this.bestSeller }}</h3>
                </v-flex>
                <v-flex xs12>
                    <div>Last 30 days best seller</div>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-flex>
  </v-layout>
  <v-layout row class="mb-3">
    <v-flex xs12>
      <v-card>
        <v-container fluid grid-list-md>
          <v-layout row>
            <v-flex>
              <v-card>
                <highcharts :options="totalSalesOptions" ref="highcharts"></highcharts>
              </v-card>
            </v-flex>
          </v-layout>
        </v-container>
      </v-card>
    </v-flex>
  </v-layout>
  <v-layout row class="mb-3">
    <v-flex xs12>
      <v-card>
        <v-layout row>
          <v-flex xs8>
            <v-layout column>
              <v-flex>
                  <v-container fluid grid-list-md>
                    <v-layout row>
                      <v-flex>
                        <v-card>
                          <highcharts :options="profitVsIncomeOptions" ref="highcharts"></highcharts>
                        </v-card>
                      </v-flex>
                    </v-layout>
                  </v-container>
              </v-flex>
            </v-layout>
          </v-flex>
          <v-flex xs4 class="mr-3">
              <v-layout column>
                <v-flex>
                  <v-data-table :items="this.incomeSummary" hide-actions>
                    <template slot="items" slot-scope="props">
                      <td class="pl-0 pr-0">{{ props.item.text }}</td>
                      <td class="text-xs-right pl-0 pr-1">{{ formatMoney(props.item.amount) }}</td>
                    </template>
                    <template slot="footer">
                      <tr>
                          <td class="pl-0 pr-0">Total</td>
                          <td class="text-xs-right pl-0 pr-1"><span class="green--text darken-2">{{ formatMoney(this.totalIncome) }}</span></td>
                      </tr>
                    </template>
                  </v-data-table>
                </v-flex> 
              </v-layout>
          </v-flex>
        </v-layout>
      </v-card>
    </v-flex> 
  </v-layout>
</v-app>`,
    data: function() {
        return { 
            totalSaleIncome: 0,
            totalSaleIncomeChange: 0,
            totalOrders: 0,
            totalOrdersChange: 0,
            totalItems: 0,
            totalItemsChange: 0,
            bestSeller: '',

            totalSalesOptions: {
                chart: {
                    type: 'spline'
                },
                title: {
                  text: 'Total Sales',
                  align: 'left',
                },
                subtitle: {
                  text: 'Last 7 days',
                  align: 'left',
                },
                xAxis: {
                  categories: []
                },
                yAxis: [{
                    title: {
                        text: 'Total Orders'
                      },
                      plotLines: [{
                        value: 0,
                        width: 1,
                        color: '#808080'
                      }]
                  },{
                    labels: {
                        format: '${value}',
                    },
                    title: {
                        text: 'Income ($)'
                    },
                    opposite: true
                }],
                legend: {
                  layout: 'vertical',
                  align: 'right',
                  verticalAlign: 'middle',
                  borderWidth: 0
                },
                series: [{
                    name: 'Orders',
                    type: 'column',
                    data: [],            
                },{
                    name: 'Income',
                    type: 'spline',
                    data: [],
                    yAxis: 1,
                    tooltip: {
                      valuePrefix: '$ '
                    }
                }],
                responsive: {
                    rules: [{
                        condition: {
                            maxWidth: 500
                        },
                        chartOptions: {
                            legend: {
                                layout: 'horizontal',
                                align: 'center',
                                verticalAlign: 'bottom'
                            }
                        }
                    }]
                }
            },
            profitVsIncomeOptions: {
                chart: {
                    plotBackgroundColor: null,
                    plotBorderWidth: null,
                    plotShadow: false,
                    type: 'pie'
                },
                title: {
                    text: 'Income Summary'
                },
                tooltip: {
                    pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
                },
                plotOptions: {
                    pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: true,
                            format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                            style: {
                                color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                            }
                        }
                    }
                },
                series: [{
                    colorByPoint: true,
                    data: [{
                        name: 'Pending',
                        y: 0,
                        sliced: false,
                        selected: false
                    }, {
                        name: 'Received',
                        y: 0,
                        sliced: true,
                        selected: true
                    }]
                }]
            },
            incomeSummary: [
                { text: 'Received', amount: 0 },
                { text: 'Pending', amount: 0 }
            ],
            totalIncome: 0
        }
    },
    computed: {
      isTotalSaleIncomeChangePositive: function() {
        return this.totalSaleIncomeChange >= 0;
      },
      isTotalOrdersChangePositive: function() {
        return this.totalOrdersChange >= 0;
      },
      isTotalItemsChangePositive: function() {
        return this.totalItemsChange >= 0;
      },
    },
    created () {
      serverBus.$emit('changePageTitle', 'Dashboard');
      serverBus.$on('signedIn', () => {
        this.loadDashboard()
      });
    },
    mounted: function() {
      this.loadDashboard();
    },
    methods: {
      loadDashboard: function() {

        let f = this;
        let interval = setInterval(function() {
          if ( app.dataUrl != undefined )
            clearInterval(interval);

          axios
            .get( app.dataUrl + '?action=admin/dashboard', { })
            .then( response => { 
                if(!response.data.status && response.data.signout) {
                    app.signOut();
                }
                if(response.data.token) {
                    app.token = response.data.token;
                    localStorage.setItem('m2m-admin-token', response.data.token);
                }

                f.totalSaleIncome = response.data.data[0].total;
                f.totalSaleIncomeChange = response.data.data[0].totalChange;
                f.totalOrders = response.data.data[0].orderQty;
                f.totalOrdersChange = response.data.data[0].orderQtyChange;
                f.totalItems = response.data.data[0].itemQty;
                f.totalItemsChange = response.data.data[0].itemQtyChange;
                f.bestSeller = response.data.data[0].bestSeller;

                f.totalSalesOptions.xAxis.categories = [];
                f.totalSalesOptions.series[0].data = [];
                f.totalSalesOptions.series[1].data = [];
                
                let acumIncome = 0;
                response.data.data[1].forEach(item => {
                  //acumIncome += parseFloat(item.totalIncome);
                  f.totalSalesOptions.xAxis.categories.push( item.label );
                  f.totalSalesOptions.series[0].data.push( parseInt(item.orderQty) );
                  f.totalSalesOptions.series[1].data.push( Math.round( item.totalIncome ) );
                });
                
                f.profitVsIncomeOptions.series[0].data[0].y = parseFloat(response.data.data[2].pending);
                f.profitVsIncomeOptions.series[0].data[1].y = parseFloat(response.data.data[2].received);

                f.incomeSummary[0].amount = response.data.data[2].received;
                f.incomeSummary[1].amount = response.data.data[2].pending;
                f.totalIncome = response.data.data[2].total;
            });
        }, 200);
      },
      formatMoney: function(n, c, d, t) {
        var c = isNaN(c = Math.abs(c)) ? 2 : c,
          d = d == undefined ? "." : d,
          t = t == undefined ? "," : t,
          s = n < 0 ? "-" : "",
          i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))),
          j = (j = i.length) > 3 ? j % 3 : 0;
      
        return '$' + s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
      },
      formatPercentage: function(n, c, d, t) {
        var c = isNaN(c = Math.abs(c)) ? 2 : c,
          d = d == undefined ? "." : d,
          t = t == undefined ? "," : t,
          s = n < 0 ? "-" : "",
          i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))),
          j = (j = i.length) > 3 ? j % 3 : 0;
      
        return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "") + '%';      },
    }
});