var checkout = Vue.component('m2m-customerInformation', {
    template: `<v-app>
    <v-container fluid fill-width>
        <v-layout row wrap fluid>
            <v-flex xs12 v-if="this.order != null" class="mb-3">
                <v-card color="green lighten-1" class="">
                    <v-card-title primary-title>
                        <div class="headline" style="width:100%;">
                            <div class="text-xs-right caption">Order #{{ order.id }}</div>
                            <div style="margin-top:-32px;">
                                <v-icon large>done</v-icon>Thank you for your order!
                            </div>
                        </div>
                        <div>Your order has been received. Our representative will guide you through the next steps.</div>
                    </v-card-title>
                    <v-card-actions>
                        <v-btn flat dark @click="printReceipt()">Print order</v-btn>
                        <v-btn flat dark @click="restart()">Start new order</v-btn>
                    </v-card-actions>
                </v-card>
            </v-flex>
            <v-flex xs6>
                <v-layout column>
                    <v-flex xs12>
                        <v-card>
                            <v-card-title class="headline">
                                <v-icon medium>account_box</v-icon>Customer Information
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="form" v-model="valid">
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="name" :rules="nameRules" label="First Name" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs4 class="ml-2">
                                            <v-text-field v-model="lastName" :rules="lastNameRules" label="Last Name"
                                                required></v-text-field>
                                        </v-flex>
                                        <v-flex xs2 class="ml-2">
                                            <v-select :items="genderOptions" v-model="gender" label="Gender" :rules="genderRules"></v-select>
                                        </v-flex>
                                        <v-flex xs3 class="ml-2">
                                            <v-text-field v-model="birthDate" :rules="birthDateRules" label="Birth Date"
                                                mask="##/##/####" hint="mm/dd/yyyy" persistent-hint required></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs4>
                                            <v-text-field v-model="email" :rules="emailRules" label="E-mail" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs4 class="ml-2">
                                            <v-text-field v-model="phone" :rules="phoneRules" label="Phone Number" mask="phone"
                                                required></v-text-field>
                                        </v-flex>
                                        <v-flex xs4 class="ml-2">
                                            <v-text-field v-model="eventRegistry" label="Event Registry"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs6>
                                            <v-text-field v-model="addressLine1" :rules="addressLine1Rules" label="Address Line 1"
                                                required></v-text-field>
                                        </v-flex>
                                        <v-flex xs6 class="ml-2">
                                            <v-text-field v-model="addressLine2" label="Address Line 2"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs4>
                                            <v-text-field v-model="addressCity" :rules="addressCityRules" label="City"
                                                required></v-text-field>
                                        </v-flex>
                                        <v-flex xs2 class="ml-2">
                                            <v-text-field v-model="addressState" :rules="addressStateRules" label="State"
                                                mask="AA" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs2 class="ml-2">
                                            <v-text-field v-model="addressZipCode" :rules="addressZipCodeRules" label="Zip Code"
                                                mask="#####" required></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                </v-form>
                            </v-card-text>
                        </v-card>
                    </v-flex>
                    <v-flex xs12>
                        <v-card>
                            <v-card-title class="headline">
                                <v-icon medium>favorite</v-icon>Contact
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="form4" v-model="valid">
                                    <v-layout row>
                                        <v-flex xs6>
                                            <v-text-field v-model="loveFullName" label="Full Name"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 class="ml-2">
                                            <v-text-field v-model="lovePhone" label="Phone" mask="phone"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 class="ml-2">
                                            <v-text-field v-model="loveEmail" label="Email"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                </v-form>
                            </v-card-text>
                        </v-card>
                    </v-flex>
                    <v-flex xs12>
                        <v-card>
                            <v-card-title class="headline">
                                <v-icon medium>accessibility</v-icon>Measurements
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="form1" v-model="valid">
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="heightFeet" :rules="heightFeetRules" label="Height - Feet"
                                                suffix="ft" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="heightInches" :rules="heightInchesRules" label="Height - Inches"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="weight" :rules="weightRules" label="Weight" suffix="lbs"
                                                required></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-select v-model="watchHand" :items="watchHandOptions" :rules="[v => !!v || 'A watch habd option is required']"
                                                label="Watch Hand" required></v-select>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="neck" :rules="neckRules" label="Neck" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('neck')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="sleeveLeft" :rules="sleeveRules" label="Sleeve Length - Left"
                                                suffix="in" required append-icon="videocam" @click:append="showVideo('sleeveLength')"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="sleeveRight" :rules="sleeveRules" label="Sleeve Length - Right"
                                                suffix="in" required append-icon="videocam" @click:append="showVideo('sleeveLength')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="bicep" :rules="bicepRules" label="Biceps" suffix="in"
                                                    required  append-icon="videocam" @click:append="showVideo('bicep')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="wrist" :rules="wristRules" label="Wrist" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('wrist')"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="chest" :rules="chestRules" label="Chest" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('chest')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="waist" :rules="waistRules" label="Waist" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('waist')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="stomach" :rules="stomachRules" label="Stomach"
                                                suffix="in" required append-icon="videocam" @click:append="showVideo('stomach')"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="hips" :rules="hipsRules" label="Hips" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('hips')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="leg" :rules="legRules" label="Leg Length" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('legLength')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="thigh" :rules="thighRules" label="Thigh" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('thigh')"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="knee" :rules="kneeRules" label="Knee" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('knee')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="calf" label="Calf" suffix="in"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="cuff" :rules="cuffRules" label="Cuff" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('cuff')"></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="crotch" :rules="crotchRules" label="Crotch" suffix="in"
                                                required append-icon="videocam" @click:append="showVideo('crotch')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="shoulder" :rules="shoulderRules" label="Shoulders"
                                                suffix="in" required append-icon="videocam" @click:append="showVideo('shoulder')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="coatSleeveLeft" :rules="coatSleeveRules" label="Coat Sleeve Length - Left"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="coatSleeveRight" :rules="coatSleeveRules" label="Coat Sleeve Length - Right"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="jacketFront" :rules="jacketFrontRules" label="Jacket Length - Front"
                                                suffix="in" required append-icon="videocam" @click:append="showVideo('jacketLength')"></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="jacketBack" :rules="jacketBackRules" label="Jacket Length - Back"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs3>
                                            <v-text-field v-model="vestFront" :rules="vestFrontRules" label="Vest - Front"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                            <v-text-field v-model="vestBack" :rules="vestBackRules" label="Vest - Back"
                                                suffix="in" required></v-text-field>
                                        </v-flex>
                                        <v-flex xs3 offset-xs1>
                                        </v-flex>
                                    </v-layout>
                                    <v-layout row>
                                        <v-flex xs12>
                                            <v-textarea name="input-7-1" label="Notes" v-model="measurementNotes" rows="3"></v-textarea>
                                        </v-flex>
                                    </v-layout>
                                </v-form>
                            </v-card-text>
                        </v-card>
                    </v-flex>
                </v-layout>
            </v-flex>
            <v-flex xs5 offset-xs1>
                <v-layout column>
                    <v-flex xs12>
                        <v-card>
                            <v-card-title class="headline">
                                <v-icon medium>receipt</v-icon>Order Summary
                            </v-card-title>
                            <v-card-text>
                                <v-data-table :headers="headers" :items="items" hide-actions class="elevation-0">
                                    <template slot="items" slot-scope="props">
                                        <td>
                                            {{ props.item.productName }} <v-tooltip right><v-icon small v-if="props.item.isCouture" slot="activator">accessibility_new</v-icon><span>Couture Item</span></v-tooltip>
                                        </td>
                                        <td class="text-xs-right">
                                            {{ formatMoney(props.item.price) }}
                                        </td>
                                        <td class="text-xs-right">
                                            {{ props.item.qty }}
                                        </td>
                                        <td class="text-xs-right">{{ formatMoney(props.item.price * props.item.qty) }}</td>
                                    </template>
                                    <template slot="footer">
                                        <tr v-if="this.specialCharges.length > 0">
                                            <td colspan="2" class="body-2 grey lighten-4">
                                                <table>
                                                    <tr>
                                                        <td class="pa-0">Special charges</td>
                                                    </tr>
                                                    <tr class="pl-3">
                                                        <td>
                                                            <v-list dense style="min-width:200px;background:none;">
                                                                <v-list-tile v-for="sCharge in this.specialCharges"
                                                                    :key="sCharge.name">
                                                                    <v-list-tile-content>{{ sCharge.name }}:</v-list-tile-content>
                                                                    <v-list-tile-content class="align-end">{{
                                                                        formatMoney(sCharge.amount) }}</v-list-tile-content>
                                                                </v-list-tile>
                                                            </v-list>
                                                        </td>
                                                    </tr>
                                                </table>
                                            </td>
                                            <td colspan="2" class="text-xs-right body-2 grey lighten-4">
                                                {{ formatMoney(this.specialChargesTotal) }}
                                            </td>
                                        </tr>
                                        <tr>
                                            <td colspan="2" class="body-2 grey lighten-4">
                                                Subtotal
                                            </td>
                                            <td colspan="2" class="text-xs-right body-2 grey lighten-4">
                                                {{ formatMoney(this.subtotal) }}
                                            </td>
                                        </tr>
                                        <tr v-if="this.discountVisible">
                                            <td colspan="2" class="body-2 grey lighten-4">
                                                Discount
                                            </td>
                                            <td colspan="2" class="text-xs-right body-2 grey lighten-4">
                                                <v-tooltip left>
                                                    <span slot="activator">
                                                        <v-icon small>info</v-icon> - {{
                                                        formatMoney(this.discountInfo.amount) }}
                                                    </span>
                                                    <span>{{ this.discountInfo.note }}</span>
                                                </v-tooltip>
                                            </td>
                                        </tr>
                                        <tr v-if="this.couponVisible">
                                            <td colspan="2" class="body-2 grey lighten-4">
                                                Coupon [{{ this.couponInfo.coupon_code }}]
                                            </td>
                                            <td colspan="2" class="text-xs-right body-2 grey lighten-4">
                                                <span> - {{ formatMoney(this.couponInfo.balance) }}</span>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td colspan="2" class="body-2 grey lighten-4">
                                                Tax
                                            </td>
                                            <td colspan="2" class="text-xs-right body-2 grey lighten-4">
                                                {{ formatMoney(this.tax) }}
                                            </td>
                                        </tr>
                                        <tr>
                                            <td colspan="2" class="title grey lighten-4">
                                                Total
                                            </td>
                                            <td colspan="2" class="text-xs-right title grey lighten-4">
                                                <span class="green--text darken-2">{{ formatMoney(this.total) }}</span>
                                            </td>
                                        </tr>
                                    </template>
                                </v-data-table>
                            </v-card-text>
                        </v-card>
                    </v-flex>
                    <v-flex xs12>
                        <v-card>
                            <v-card-title class="headline">
                                <v-icon medium>payment</v-icon>Financial Information
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="form2" v-model="valid">
                                    <v-layout row wrap fill-height align-center>
                                        <v-flex xs4 class="mb-3">
                                            <p>Payment Method</p>
                                        </v-flex>
                                        <v-flex xs8 class="mb-3">
                                            <v-select :items="paymentMethods" v-model="paymentMethod" label="" @change="updatePaymentMethod"></v-select>
                                        </v-flex>
                                        <v-flex xs12>
                                            <v-layout row>
                                                <v-flex xs6>
                                                    <v-form v-model="valid">
                                                        <v-select v-model="paymentSelect" :items="paymentOptions"
                                                            :rules="[v => !!v || 'A payment Option is required']" label="Payment Options"
                                                            @change="updatePaymentAmount()" required></v-select>
                                                    </v-form>
                                                </v-flex>
                                                <v-flex xs5 offset-xs1 class="text-xs-right">
                                                    <v-form v-model="valid">
                                                        <v-text-field v-model="paymentAmount" :rules="paymentAmountRules"
                                                            label="Payment Amount" :readonly="paymentAmountDisable"
                                                            prefix="$"></v-text-field>
                                                    </v-form>
                                                </v-flex>
                                            </v-layout>
                                        </v-flex>
                                        <v-flex xs12 v-if="this.paymentMethod == 'Stripe'">
                                            <div id="card-element"></div>
                                        </v-flex>
                                        <v-flex xs12 v-if="this.paymentMethod != 'Stripe'">
                                            <v-form v-model="valid">
                                                <v-text-field v-model="posConfirmationNumber" :rules="posConfirmationNumberRules"
                                                    label="Confirmation Number"></v-text-field>
                                            </v-form>
                                        </v-flex>
                                        <v-flex xs12>
                                            <div id="card-errors" role="alert" style="margin-top:10px;color:red;"></div>
                                        </v-flex>
                                    </v-layout>
                                </v-form>
                            </v-card-text>
                        </v-card>
                    </v-flex>
                </v-layout>
            </v-flex>
        </v-layout>
        <v-layout row wrap fluid>
            <v-flex xs6>
                <v-card>
                    <v-card-title class="headline">Stylist Information</v-card-title>
                    <v-card-text>
                        <v-form ref="form3" v-model="valid">
                            <v-layout row>
                                <v-flex xs6>
                                    <v-text-field v-model="rep" :rules="repRules" label="Stylist Code" required></v-text-field>
                                </v-flex>
                                <v-flex xs6 class="ml-2">
                                    <v-text-field v-model="referral" label="Referral Code"></v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-form>
                    </v-card-text>
                </v-card>
            </v-flex>
        </v-layout>
    </v-container>
    <div>
        <v-btn color="green" dark large fixed bottom right @click="processPayment()" v-if="this.order == null">Process
            Payment</v-btn>
    </div>
    <v-snackbar v-model="snackbar" color="error" :top="true" :multi-line="false" :timeout="3000">
        <div>
            {{ snackbarText }}
        </div>
    </v-snackbar>
    <v-dialog v-model="dialog" scrollable max-width="500">
        <v-card>
            <v-card-title class="headline red darken-1">
                <v-icon>error</v-icon> Missing Information
            </v-card-title>
            <v-divider></v-divider>
            <v-card-text>Your form has the following errors.</v-card-text>
            <v-card-text style="height: 300px;" class="pt-0 pb-0">
                <v-container fluid fill-width class="pt-0 pb-0">
                    <v-layout row wrap fluid>
                        <v-flex xs12>
                            <v-list subheader>
                                <v-list-tile avatar v-for="error in errorMessageList" :key="error">
                                    <v-list-tile-content>
                                        <v-list-tile-title class="caption">{{ error }}</v-list-tile-title>
                                    </v-list-tile-content>
                                </v-list-tile>
                            </v-list>
                        </v-flex>
                    </v-layout>
                </v-container>
            </v-card-text>
            <v-divider></v-divider>
            <v-card-actions>
                <v-btn color="grey darken-1" flat @click.native="dialog = false" style="margin-left:auto; margin-right:0;">Ok</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
    <v-dialog v-model="tutorialDialog" width="640" height="360">
      <v-card>
        <v-card-text class="pa-0">
            <iframe :src="tutorialVideo" width="640" height="360" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>
        </v-card-text>
      </v-card>
    </v-dialog>
</v-app>`,
    props: [],
    data: function() {
        return {
            stripe: 'test', 
            elements: undefined, 
            card: undefined,
            valid: false,
            name: '',
            nameRules: [
                v => !!v || 'First name is required'
            ],
            lastName: '',
            lastNameRules: [
                v => !!v || 'Last name is required'
            ],
            gender: '',
            genderRules: [
                v => !!v || 'The gender field is required'
            ],
            genderOptions: [
                { text: 'Male', value: 'm' },
                { text: 'Female', value: 'f' },
                { text: 'Neutral', value: 'n' }
            ],
            birthDate: '',
            birthDateRules: [
                v => !!v || 'The birth date is required',
                v => this.validateDate() || 'The birth date must be valid',
            ],
            email: '',
            emailRules: [
                v => !!v || 'E-mail is required',
                v => /.+@.+/.test(v) || 'E-mail must be valid'
            ],
            phone: '',
            phoneRules: [
                v => !!v || 'Phone number is required',
                v => /^[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-\s\./0-9]*$/g.test(v) || 'Phone number must be valid'
            ],
            eventRegistry: '',
            addressLine1: '',
            addressLine1Rules: [
                v => !!v || 'The address is required',
            ],
            addressLine2: '',
            addressCity: '',
            addressCityRules: [
                v => !!v || 'The city is required',
            ],
            addressState: 'PR',
            addressStateRules: [
                v => !!v || 'The state is required',
            ],
            addressZipCode: '',
            addressZipCodeRules: [
                v => !!v || 'The zip code is required',
            ],
            loveFullName: '',
            lovePhone: '',
            loveEmail: '',
            heightFeet: '',
            heightFeetRules: [
                v => !!v || 'Feet are required',
                v => /[3-7]{1}/g.test(v) || 'Feet must be valid'
            ],
            heightInches: '',
            heightInchesRules: [
                v => !!v || 'Inches are required',
                v => v >= 0 && v <= 11 || 'Inches must be valid'
            ],
            weight: '',
            weightRules: [
                v => !!v || 'Weight is required',
                v => this.tryParseInt(v, false) || 'Weight must be valid'
            ],
            neck: '',
            neckRules: [
                v => !!v || 'Neck is required',
                v => this.tryParseInt(v, false) || 'Neck must be valid'
            ],
            shoulder: '',
            shoulderRules: [
                v => !!v || 'Shoulders is required',
                v => this.tryParseInt(v, false) || 'Shoulders must be valid'
            ],
            coatSleeveLeft: '',
            coatSleeveRight: '',
            coatSleeveRules: [
                v => !!v || 'Coat Sleeve is required',
                v => this.tryParseInt(v, false) || 'Coat Sleeve must be valid'
            ],
            sleeveLeft: '',
            sleeveRight: '',
            sleeveRules: [
                v => !!v || 'Sleeve Length is required',
                v => this.tryParseInt(v, false) || 'Sleeve Length must be valid'
            ],
            bicep: '',
            bicepRules: [
                v => !!v || 'Bicep is required',
                v => this.tryParseInt(v, false) || 'Bicep must be valid'
            ],
            wrist: '',
            wristRules: [
                v => !!v || 'Wrist is required',
                v => this.tryParseInt(v, false) || 'Wrist must be valid'
            ],
            chest: '',
            chestRules: [
                v => !!v || 'Chest is required',
                v => this.tryParseInt(v, false) || 'Chest must be valid'
            ],
            stomach: '',
            stomachRules: [
                v => !!v || 'Stomach is required',
                v => this.tryParseInt(v, false) || 'Stomach must be valid'
            ],
            jacketFront: '',
            jacketFrontRules: [
                v => !!v || 'Jacket Length - Front is required',
                v => this.tryParseInt(v, false) || 'Jacket Length - Front must be valid'
            ],
            jacketBack: '',
            jacketBackRules: [
                v => !!v || 'Jacket Length - Back is required',
                v => this.tryParseInt(v, false) || 'Jacket Length - Back must be valid'
            ],
            waist: '',
            waistRules: [
                v => !!v || 'Waist Length is required',
                v => this.tryParseInt(v, false) || 'Waist Length must be valid'
            ],
            hips: '',
            hipsRules: [
                v => !!v || 'Hips is required',
                v => this.tryParseInt(v, false) || 'Hips must be valid'
            ],
            thigh: '',
            thighRules: [
                v => !!v || 'Thigh is required',
                v => this.tryParseInt(v, false) || 'Thigh must be valid'
            ],
            crotch: '',
            crotchRules: [
                v => !!v || 'Crotch is required',
                v => this.tryParseInt(v, false) || 'Crotch must be valid'
            ],
            knee: '',
            kneeRules: [
                v => !!v || 'Knee is required',
                v => this.tryParseInt(v, false) || 'Knee must be valid'
            ],
            leg: '',
            legRules: [
                v => !!v || 'Leg is required',
                v => this.tryParseInt(v, false) || 'Leg must be valid'
            ],
            watchHand: '',
            rep: '',
            repRules: [
                v => !!v || 'The stylist code is required'
            ],
            referral: '',
            vestFront: '',
            vestFrontRules: [
                v => !!v || 'Vest - Front is required',
                v => this.tryParseInt(v, false) || 'Vest - Front must be valid'
            ],
            vestBack: '',
            vestBackRules: [
                v => !!v || 'Vest - Back is required',
                v => this.tryParseInt(v, false) || 'Vest - Back must be valid'
            ],
            calf: '',
            cuff: '',
            cuffRules: [
                v => !!v || 'Cuff is required',
                v => this.tryParseInt(v, false) || 'Cuff must be valid'
            ],
            measurementNotes: '',
            formHasError: false,
            items: [],
            headers: [
                { text: 'Product', value: 'productName', sortable: false, align: 'left', width: '70%' },
                { text: 'Price', value: 'price', sortable: false, align: 'right', width: '10%' },
                { text: 'Qty', value: 'qty', sortable: false, align: 'right', width: '10%' },
                { text: 'Total', value: 'total', sortable: false, align: 'right', width: '10%' }
            ],
            paymentSelect: 'Total Amount',
            paymentOptions: [
                'Total Amount',
                '50%',
            ],
            watchHandOptions: [
                'Left',
                'Right',
                'None'
            ],
            paymentAmount: this.total,
            paymentAmountRules: [
                v => this.tryParseInt(this.formatPaymentAmount(v).toString(), false) || 'Payment Amount must be valid',
                v => this.formatPaymentAmount(v) <= this.formatPaymentAmount(this.total + 0.01) || 'Payment Amount cannot be greated than order total',
            ],
            posConfirmationNumber: '',
            posConfirmationNumberRules: [
                v => !!v || 'Payment confirmation number is required'
            ],
            paymentAmountDisable: true,
            snackbar: false,
            snackbarText: '',
            token: null,
            dialog: false,
            errorMessageList: [],
            order: null,
            processing: false,
            paymentMethod: null,
            tutorialDialog: false,
            tutorialVideo: '',
            paymentMethods: [
                { text: 'American Express', value: 'Amex' },
                { text: 'ATH / Debit', value: 'Debit' },
                { text: 'Cash', value: 'Cash' }, 
                { text: 'Discover', value: 'Discover' },
                { text: 'Master Card', value: 'MasterCard' },
                { text: 'Online', value: 'Stripe' },
                { text: 'Visa', value: 'Visa' }
            ]
        }
    },
    created () {
        app.pageStack[app.pageStack.length - 1].disabled = false;
        app.pageStack.push( {
            text: 'Checkout',
            disabled: true,
            href: '#/checkout'
        });

        serverBus.$on('showCheckoutDialog', (errorList) => {
            this.showDialog(errorList);
        });
        serverBus.$on('orderCompleted', ( order ) => {
            this.order = order;
            app.store.cart = [];
            app.store.discount = {
                amount: 0,
                note: ''
            };
            app.store.specialCharges = [];
            app.store.coupon = {};

            $('html, body').animate({ scrollTop: 0 }, 'fast');
        });

        serverBus.$on('saveCheckout', () => {
            app.store.savedCheckout = this.form;
            console.log('Checkout Information Saved!');
        });

        this.items = app.store.cart;
        if( app.store.savedCheckout != null ) {
            this.name = app.store.savedCheckout.customerName;
            this.lastName = app.store.savedCheckout.customerLastName;
            this.email = app.store.savedCheckout.customerEmail;
            this.phone = app.store.savedCheckout.customerPhone;
            this.gender = app.store.savedCheckout.customerGender;
            this.birthDate = app.store.savedCheckout.customerBirthdate.split('-')[1] + app.store.savedCheckout.customerBirthdate.split('-')[2] + app.store.savedCheckout.customerBirthdate.split('-')[0];
            this.eventRegistry = app.store.savedCheckout.customerEventCode;
            this.addressLine1 = app.store.savedCheckout.customerAddressLine1;
            this.addressLine2 = app.store.savedCheckout.customerAddressLine2;
            this.addressCity = app.store.savedCheckout.customerCity;
            this.addressState = app.store.savedCheckout.customerState;
            this.addressZipCode = app.store.savedCheckout.customerZipcode;
            this.loveFullName = app.store.savedCheckout.partnerFullName;
            this.lovePhone = app.store.savedCheckout.partnerPhone;
            this.loveEmail = app.store.savedCheckout.partnerEmail;
            this.heightFeet = app.store.savedCheckout.customerMeasurements.heightFeet;
            this.heightInches = app.store.savedCheckout.customerMeasurements.heightInches;
            this.weight = app.store.savedCheckout.customerMeasurements.weight;
            this.neck = app.store.savedCheckout.customerMeasurements.neck;
            this.shoulder = app.store.savedCheckout.customerMeasurements.shoulder;
            this.sleeveLeft = app.store.savedCheckout.customerMeasurements.sleeveLengthLeft;
            this.sleeveRight = app.store.savedCheckout.customerMeasurements.sleeveLengthRight;
            this.coatSleeveLeft = app.store.savedCheckout.customerMeasurements.coatSleeveLengthLeft;
            this.coatSleeveRight = app.store.savedCheckout.customerMeasurements.coatSleeveLengthRight;
            this.bicep = app.store.savedCheckout.customerMeasurements.bicep;
            this.wrist = app.store.savedCheckout.customerMeasurements.wrist;
            this.chest = app.store.savedCheckout.customerMeasurements.chest;
            this.stomach = app.store.savedCheckout.customerMeasurements.stomach;
            this.jacketFront = app.store.savedCheckout.customerMeasurements.jacketLengthFront;
            this.jacketBack = app.store.savedCheckout.customerMeasurements.jacketLengthBack;
            this.vestFront = app.store.savedCheckout.customerMeasurements.vestFront;
            this.vestBack = app.store.savedCheckout.customerMeasurements.vestBack;
            this.waist = app.store.savedCheckout.customerMeasurements.waist;
            this.hips = app.store.savedCheckout.customerMeasurements.hips;
            this.thigh = app.store.savedCheckout.customerMeasurements.thigh;
            this.crotch = app.store.savedCheckout.customerMeasurements.crotch;
            this.knee = app.store.savedCheckout.customerMeasurements.knee;
            this.leg = app.store.savedCheckout.customerMeasurements.legLength;
            this.cuff = app.store.savedCheckout.customerMeasurements.cuff;
            this.watchHand =  app.store.savedCheckout.customerMeasurements.watchHand;
            this.calf = app.store.savedCheckout.customerMeasurements.calf;
            this.measurementNotes = app.store.savedCheckout.customerMeasurements.measurementNotes;

            this.rep = app.store.savedCheckout.rep;
            this.referral = app.store.savedCheckout.referral;
            this.paymentMethod = app.store.savedCheckout.paymentMethod;
            this.paymentAmount = app.store.savedCheckout.paymentAmount;
        }
    },
    mounted () {
        // load Stripe script
        let stripeScript = document.createElement('script');
        stripeScript.setAttribute('src', 'https://js.stripe.com/v3/');
        document.body.appendChild(stripeScript);

        let style = {
            base: {
              // Add your base input styles here. For example:
              fontSize: '18px',
              color: "#000",
              fontFamily: 'Roboto,sans-serif'
            }
        };

        setTimeout(() => { 
            // this.stripe = Stripe(`pk_test_o09PtlJcY7qLjqxmFBzAwVdp`); // Development
            this.stripe = Stripe(`pk_live_tQ9N5caSTachhcYvcH3vyCll`); // Live
            this.elements = this.stripe.elements();
            this.card = this.elements.create('card', { style: style } );

            if ( this.paymentMethod == 'Stripe' )
                this.card.mount('#card-element');

            this.card.addEventListener('change', function(event) {
                var displayError = document.getElementById('card-errors');
                if (event.error) {
                    displayError.textContent = event.error.message;
                } else {
                    displayError.textContent = '';
                }
            });
        }, 2000);

        this.paymentAmount = this.formatMoneyWithoutSymbol( this.total );
        if(app.store.isLcsLogged)
            this.paymentOptions.push('No payment');
    },
    computed: {
        form: function () {
            return {
                customerName: this.name,
                customerLastName: this.lastName,
                customerEmail: this.email,
                customerPhone: this.phone,
                customerGender: this.gender,
                customerBirthdate: this.birthDateFormatted,
                customerEventCode: this.eventRegistry,
                customerAddressLine1: this.addressLine1,
                customerAddressLine2: this.addressLine2,
                customerCity: this.addressCity,
                customerState: this.addressState,
                customerZipcode: this.addressZipCode,
                partnerFullName: this.loveFullName,
                partnerPhone: this.lovePhone,
                partnerEmail: this.loveEmail,
                customerMeasurements: {
                    heightFeet: this.heightFeet,
                    heightInches: this.heightInches,
                    weight: this.weight,
                    neck: this.neck,
                    shoulder: this.shoulder,
                    sleeveLengthLeft: this.sleeveLeft,
                    sleeveLengthRight: this.sleeveRight,
                    coatSleeveLengthLeft: this.coatSleeveLeft,
                    coatSleeveLengthRight: this.coatSleeveRight,
                    bicep: this.bicep,
                    wrist: this.wrist,
                    chest: this.chest,
                    stomach: this.stomach,
                    jacketLengthFront: this.jacketFront,
                    jacketLengthBack: this.jacketBack,
                    vestFront: this.vestFront,
                    vestBack: this.vestBack,
                    waist: this.waist,
                    hips: this.hips,
                    thigh: this.thigh,
                    crotch: this.crotch,
                    knee: this.knee,
                    calf: this.calf,
                    legLength: this.leg,
                    cuff: this.cuff,
                    watchHand: this.watchHand,
                    measurementNotes: this.measurementNotes,
                },
                rep: this.rep,
                referral: this.referral,
                items: app.store.cart,
                subtotal: this.subtotal,
                tax: this.tax,
                total: this.total,
                paymentMethod: this.paymentMethod,
                paymentAmount: this.paymentAmount,
                paymentToken: this.token,
                paymentConfirmationNumber: this.posConfirmationNumber,
                discountNote: this.discountInfo.note,
                discountAmount: this.discountInfo.amount,
                specialCharges: this.specialCharges,
                couponCode: _.isEmpty(this.couponInfo) ? '' : this.couponInfo.coupon_code,
                couponAmountUsed: this.couponAmountUsed,
                store: app.store.store,
            }
        },
        subtotal: function() {
            let subtotal = this.specialChargesTotal;
            for( let i = 0; i < app.store.cart.length; i++ ) {
                subtotal += app.store.cart[i].price * app.store.cart[i].qty;
            }

            return subtotal;
        },
        tax: function() {
            let couponAmt = 0;
            if(!_.isEmpty(this.couponInfo))
                couponAmt = this.couponInfo.balance;

            return (this.subtotal - this.discountInfo.amount - couponAmt) * 0.115 > 0 ? (this.subtotal - this.discountInfo.amount - couponAmt) * 0.115 : 0;
        },
        total: function() {
            let couponAmt = 0;
            if(!_.isEmpty(this.couponInfo))
                couponAmt = this.couponInfo.balance;

            return this.subtotal - this.discountInfo.amount - couponAmt + this.tax > 0 ? this.subtotal - this.discountInfo.amount - couponAmt + this.tax : 0;
        },
        processPaymentBtnAvailable: function () {
            if ( this.order == null && !this.processing )
                return true;
            else 
                return false;
        },
        discountVisible: function() {
            return app.store.discount.amount > 0;
        },
        discountInfo: function() {
            return app.store.discount;
        },
        couponVisible: function() {
            return !_.isEmpty(app.store.coupon);
        },
        couponInfo: function() {
            return app.store.coupon;
        },
        couponAmountUsed: function() {
            let couponAmt = 0;
            if(!_.isEmpty(this.couponInfo))
                couponAmt = this.couponInfo.balance;

            if( couponAmt > this.subtotal - this.discountInfo.amount )
                return couponAmt - (this.subtotal - this.discountInfo.amount);
            else
                return couponAmt;
        },
        specialChargesTotal: function() {
            let total = 0;
            this.specialCharges.forEach(sCharge => {
                total += parseFloat(sCharge.amount.split(',').join(''));
            });

            return parseFloat(total);
        },
        specialCharges: function() {
            return app.store.specialCharges;
        },
        birthDateFormatted: function() {
            let month = this.birthDate.substr(0, 2);
            let day = this.birthDate.substr(2, 2);
            let year = this.birthDate.substr(4, 4);

            return year + '-' + month + '-' + day;
        }
    },
    watch: {
    },
    methods: {
        tryParseInt: function(str, defaultValue) {
            var retValue = defaultValue;
            if(str !== null) {
                if(str.length > 0) {
                    if (!isNaN(str)) {
                        // retValue = parseInt(str);
                        retValue = true;
                    }
                }
            }
            return retValue;
        },
        processPayment: function() {
            // Validate input information
            this.validateForm();
            if ( this.formHasError ) {
                this.snackbarText = 'All the fields are required. Please fill all the form before submitting the payment.';
                this.snackbar = true;
                return;
            }

            this.processing = true;
            let formData = this.form;
            if (formData.paymentMethod != 'Stripe' ) {
                let axiosOptions = {
                    method: 'POST',
                    url: app.dataUrl,
                    data: { 'form': formData },
                    params: {
                        'action': 'order'
                    },
                    headers: {
                        'Authorization': app.authKey
                    },
                    json: true
                };

                axios(axiosOptions)
                .then( response => { 
                    // If everything is ok, go to thankyou page
                    if( response.data.status == 'error' ) {
                        serverBus.$emit('showCheckoutDialog', response.data.errors);
                        return;
                    }
                    else if ( response.data.status == 'Order Created' ) {
                        serverBus.$emit('orderCompleted', response.data.order);
                        app.store.savedCheckout = null;
                        app.store.isLcsLogged = false;
                        serverBus.$emit('clearInterval');
                        return;
                    }
                    this.processing = false;
                })
                .catch(function (error) {
                    console.log(error);
                    this.processing = false;
                });
            }
            else if (formData.paymentMethod == 'Stripe') {
                // If is valid, create Stripe token
                this.stripe.createToken(this.card).then(function(result) {
                    if (result.error) {
                        // Inform the customer that there was an error.
                        var errorElement = document.getElementById('card-errors');
                        errorElement.textContent = result.error.message;
                        this.processing = false;
                    } else {
                        this.token = result.token.id;
                        formData.paymentToken = result.token.id;
                        // Call de M2M API to charge the card and create the order.
                        
                        let axiosOptions = {
                            method: 'POST',
                            url: app.dataUrl,
                            data: { 'form': formData },
                            params: {
                                'action': 'order'
                            },
                            headers: {
                                'Authorization': app.authKey
                            },
                            json: true
                        };

                        axios(axiosOptions)
                        .then( response => { 
                            // If everything is ok, go to thankyou page
                            if( response.data.status == 'error' ) {
                                serverBus.$emit('showCheckoutDialog', response.data.errors);
                                return;
                            }
                            else if ( response.data.status == 'Order Created' ) {
                                serverBus.$emit('orderCompleted', response.data.order);
                                app.store.savedCheckout = null;
                                app.store.isLcsLogged = false;
                                serverBus.$emit('clearInterval');
                                return;
                            }
                            this.processing = false;
                        })
                        .catch(function (error) {
                            console.log(error);
                            this.processing = false;
                        });
                    }
                });
            }
        },
        showDialog: function(errorList) {
            this.dialog = true;
            this.errorMessageList = errorList;
        },
        validateForm: function() {
            let form = this.$refs.form.validate();
            let form1 = this.$refs.form1.validate();
            let form2 = this.$refs.form2.validate();
            let form3 = this.$refs.form3.validate();
            let form4 = this.$refs.form4.validate();

            if( form && form1 && form2 && form3 && form4 )
                this.formHasError = false;
            else
                this.formHasError = true;
        },
        formatMoney: function(val) {
            return '$' + this.formatMoneyWithoutSymbol(val);
        },
        formatMoneyWithoutSymbol: function(n, c, d, t) {
            var c = isNaN(c = Math.abs(c)) ? 2 : c,
              d = d == undefined ? "." : d,
              t = t == undefined ? "," : t,
              s = n < 0 ? "-" : "",
              i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))),
              j = (j = i.length) > 3 ? j % 3 : 0;
          
            return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
        },
        updatePaymentAmount: function() {
            if(this.paymentSelect == '25%') {
                this.paymentAmount = this.formatMoneyWithoutSymbol( this.total * 0.25 );
                this.paymentAmountDisable = true;
            }
            else if(this.paymentSelect == '50%') {
                this.paymentAmount = this.formatMoneyWithoutSymbol( this.total * 0.5 );
                this.paymentAmountDisable = true;
            }
            else if(this.paymentSelect == '75%') {
                this.paymentAmount = this.formatMoneyWithoutSymbol( this.total * 0.75 );
                this.paymentAmountDisable = true;
            }
            else if(this.paymentSelect == 'Total Amount') {
                this.paymentAmount = this.formatMoneyWithoutSymbol( this.total );
                this.paymentAmountDisable = true;
            }
            else if(this.paymentSelect == 'Other') {
                this.paymentAmount = 0;
                this.paymentAmountDisable = false;
            }
            else if(this.paymentSelect == 'No payment') {
                this.paymentAmount = 0;
                this.paymentAmountDisable = true;
            }
        },
        formatPaymentAmount: function(val) {
            if ( val == undefined)
                return 0;
                
            return parseFloat(val.toString().split(',').join(''));
        },
        restart: function() {
            let currentStore = app.store.store;
            app.store = {
                typeId: null,
                productId: null,
                productName: '',
                price: 0.00,
                qty: 0,
                modifications: [],
                fabrics: [],
                availableFabrics: [],
                createdFabrics: [],
                cart: [],
                discount: {
                    amount: 0,
                    note: ''
                },
                specialCharges: [],
                isEdit: false,
                editItemIndex: null,
                measurements: {

                },
                isLcsLogged: false,
                store: currentStore,
                savedCheckout: null,
            };

            router.push('/');
        },
        printReceipt: function() {
            if ( this.order == null || this.order == undefined ) {
                return; 
            }

            axios({
                url: app.dataUrl + '?action=receipt&oid=' + this.order.id,
                method: 'GET',
                responseType: 'blob', // important
                headers: { Authorization: app.authKey }
              }).then((response) => {
                const url = window.URL.createObjectURL(new Blob([response.data]));
                const link = document.createElement('a');
                link.href = url;
                link.setAttribute('download', 'LFA_-_Made_To_Measure_Order_' + this.order.id + '.pdf');
                document.body.appendChild(link);
                link.click();
              });
        },
        validateDate: function() {
            let month = parseInt(this.birthDate.substr(0, 2));
            let day = parseInt(this.birthDate.substr(2, 2));
            let year = parseInt(this.birthDate.substr(4, 4));

            if ( month < 1 || month > 12 )
                return false;
            if ( day < 1 )
                return false;

            switch (month) {
                case 1:
                    if ( day > 31 )
                        return false;
                    break;
                case 2:
                    if ( ( day > 28 && !this.isLeapYear(year) ) || (day > 29 && this.isLeapYear(year)) )
                        return false;
                    break;
                case 3:
                    if ( day > 31 )
                        return false;
                    break;
                case 4:
                    if ( day > 30 )
                        return false;
                    break;
                case 5:
                    if ( day > 31 )
                        return false;
                    break;
                case 6:
                    if ( day > 30 )
                        return false;
                    break;
                case 7:
                    if ( day > 31 )
                        return false;
                    break;
                case 8:
                    if ( day > 31 )
                        return false;
                    break;
                case 9:
                    if ( day > 30 )
                        return false;
                    break;
                case 10:
                    if ( day > 31 )
                        return false;
                    break;
                case 11:
                    if ( day > 30 )
                        return false;
                    break;
                case 12:
                    if ( day > 31 )
                        return false;
                    break;
            }
            
            if ( year < 1920 || year > (new Date()).getFullYear() )
                return false;

            return true;
        },
        isLeapYear: function(year) {
            return ((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0);
        },
        showVideo: function(type) {
            this.tutorialVideo = 'https://player.vimeo.com/video/';
            switch(type) {
                case 'neck': this.tutorialVideo += '310569916'; break;
                case 'sleeveLength': this.tutorialVideo += '295827766'; break;
                case 'bicep': this.tutorialVideo += '295823632'; break;
                case 'wrist': this.tutorialVideo += '295828863'; break;
                case 'chest': this.tutorialVideo += '295824352'; break;
                case 'waist': this.tutorialVideo += '296455945'; break;
                case 'stomach': this.tutorialVideo += '296740024'; break;
                case 'hips': this.tutorialVideo += '296456301'; break;
                case 'legLength': this.tutorialVideo += '295826571'; break;
                case 'thigh': this.tutorialVideo += '295828289'; break;
                case 'knee': this.tutorialVideo += '295826023'; break;
                case 'cuff': this.tutorialVideo += '295825605'; break;
                case 'crotch': this.tutorialVideo += '295825029'; break;
                case 'shoulder': this.tutorialVideo += '295827483'; break;
                case 'jacketLength': this.tutorialVideo += '297733866'; break;
            }
            
            if (this.tutorialVideo.length > 0) {
                this.tutorialVideo += '?autoplay=1';
                this.tutorialDialog = true;
            }
        },
        updatePaymentMethod: function() {
            if( this.paymentMethod == 'Stripe' ) {
                setTimeout(() => { 
                    this.card.mount('#card-element');
                }, 500);
            }
            else 
                this.card.unmount('#card-element');
        }
    }
});