Vue.component('m2m-toolbar', {
    template: `
        <div>
            <v-toolbar dark class="mb-2" fixed>
                <v-layout align-center>
                    <v-toolbar-title class="white--text">
                        <router-link to="/"><img :src="logo" alt="LFA - Logo" width="40" height="40" style="padding-top:10px;" /></router-link>
                    </v-toolbar-title>
                    <v-divider class="mx-3" inset vertical dark></v-divider>
                    <span class="subheading">{{title}}</span>
                    <v-spacer></v-spacer>
                    <v-toolbar-items>
                        <router-link to="/cart">
                            <v-badge right>
                                <span slot="badge">{{ this.getCartItemQty() }}</span>
                                <v-icon medium color="grey lighten-1">
                                    shopping_cart
                                </v-icon>
                            </v-badge>
                        </router-link>
                    </v-toolbar-items>
                </v-layout>
            </v-toolbar>
            <br><br><br>
        </div>
`,
    props: ['title', 'cart', 'logo'],
    data() {
        return {

        }
    },
    methods: {
        getCartItemQty: function() {
            let qty = 0;
            this.cart.forEach(item => {
                qty += parseInt(item.qty == null || item.qty == undefined || item.qty == '' ? 0 : item.qty);
            });

            return qty;
        }
    }
})